
USE SVH_REPORT_DB
GO


/*
|| Autor: Jhon Reyes
|| Fecha: 2022.09.14
|| Proceso: Contiene el perímetro de las nuevas URs a migrar. Esto se puede dar por que en el momento del 
||				cierre estas URs no cumplian criterio para migrarlas. Si se llega a ejecutar este script, 
||				lo normal es que sea en días D+X, ya que en el día D no cumplian criterio. 				
*/

/*
|| Donde y cuando inserto las nuevas URs??
*/

--==========================================================================
--					URs a incluir en el nuevo perímetro a migrar							
--==========================================================================

			
	DECLARE @ANYOMES VARCHAR(6);
	SET @ANYOMES = CONVERT(VARCHAR(6),DATEADD(dd,-(DAY(GETDATE())),GETDATE()),112);

	DROP TABLE IF EXISTS #TMP_NUEVAS_URS_PERIMETRO
	SELECT
		SOCIEDAD,
		UNIDAD_REGISTRAL,
		CONTROL_PERIMETRO,
		PERIODO_CIERRE,
		COMENTARIOS,
		IND_EJECUCION,
		FECHA_CARGA
		INTO #TMP_NUEVAS_URS_PERIMETRO
	FROM [JUNO].[TMP_MODIFICACION_PERIMETRO_CIERRE] 
	WHERE
		IND_EJECUCION = 'X' 
		AND PERIODO_CIERRE = @ANYOMES 
		AND CONTROL_PERIMETRO = 'INCLUIR URS - UR_MAESTRO'			

/*
|| Proceso previo a la inserción de las nuevas URs
||		1. Actualizar el campo IND_MIGRACION, dejarlo vacío. Es decir, la data ya migrada se actulizará con vacío. 
||			Siempre y cuando haya mas de 1 día de diferencia entre la fecha de carga de la tabla y la fecha actual 
||		2. Insertar en la tabla TMP_UR_MAESTRO_HIST el "nuevo prímetro" con el campo IND_MIGRACION = 'X'
*/


--==========================================================================
--				1. Actualizar IND_MIGRACION = ''
--==========================================================================

UPDATE [JUNO].[TMP_UR_MAESTRO_HIST] SET IND_MIGRACION = '' --WHERE DATEDIFF(DAY, FECHA_CARGA, GETDATE()) > 0


--==========================================================================
--				2. Insertar los nuevos registros en la tabla de perimetro
--==========================================================================


INSERT INTO [JUNO].[TMP_UR_MAESTRO_HIST]
SELECT
	  UR.SOCIEDAD
	, UR.UNIDAD_REGISTRAL
	, UR.PROMOCION_COMERCIAL
	, UR.PROMOCION_CONJUNTA
	, UR.FECHA_TITULO
	, UR.FECHA_ESCRITURA_ALTA
	, UR.DESC_SOCIEDAD
	, CASE WHEN ISNULL(UR.FECHA_TITULO, '') = '' THEN UR.FECHA_ESCRITURA_ALTA ELSE UR.FECHA_TITULO END FECHA_ADJUDICACION
	, UR.PAIS 
	, UR.PROVINCIA 
	, UR.DESC_PROVINCIA
	, UR.CM_FISCAL 
	, UR.DESC_CM_FISCAL
	, UR.DESC_POBLACION 
	, UR.TIPO_VIA
	, UR.CALLE 
	, UR.NUMERO 
	, UR.BLOQUE 
	, UR.PISO 
	, UR.PUERTA
	, UR.COD_POSTAL 
	, UR.IDUFIR 
	, UR.PROVINCIA_REGISTRO 
	, UR.DESC_PROVINCIA_REGISTRO
	, UR.MUNICIPIO_REGISTRO 
	, UR.DESC_MUNICIPIO_REGISTRO
	, UR.NUM_REGISTRO 
	, UR.NUM_TOMO 
	, UR.NUM_LIBRO 
	, UR.FINCA 
	, UR.TIPO_INMUEBLE
	, UR.MODO
	, UR.DESC_TIPO_INMUEBLE
	, UR.PARALIZACION_URBANIZACION
	, UR.NUM_AUTOS 
	, UR.FECHA_POSESION
	, CASE WHEN ISNULL(UR.FECHA_POSESION, '') = '' THEN UR.FECHA_TITULO ELSE UR.FECHA_POSESION END FECHA_POSESION_RPT
	, UR.EXPEDIENTE
	, UR.CONTRATO
	, UR.CENTRO
	, UR.FECHA_REGISTRO_BAJA
	, UR.FECHA_VENTA 
	, UR.DESC_UR 
	, UR.SOCIEDAD_ORIGEN 
	, UR.FECHA_SELLO 	
	, UR.IND_STK_NEG
	, UR.IND_VENTA_REALIZADA
	, UR.IND_BAJA_REALIZADA		
	, CASE
		WHEN UR.COEFICIENTE_INDIVISA = 100 THEN 100 
		WHEN UR.COEFICIENTE_INDIVISA = 0 THEN 100
		WHEN UR.COEFICIENTE_INDIVISA IS NULL THEN 100
		ELSE 100 - UR.COEFICIENTE_INDIVISA 
	 END COEFICIENTE_INDIVISA 
	, UR.FINCA_DRM
	, UR.DESC_PROMOCION_COMERCIAL
	, UR.DESC_PROMOCION_CONJUNTA
	, UR.PRODUCTO
	, UR.DESC_PRODUCTO
	, UR.TIPO_COMERCIALIZACION
	, UR.DESC_TIPO_COMERCIALIZACION
	, UR.CODIGO_ACTUACION_ALTA
	, UR.DESC_CODIGO_ACTUACION_ALTA
	, UR.CODIGO_ACTUACION_BAJA	
	, UR.DESC_CODIGO_ACTUACION_BAJA
	, UR.FECHA_REGISTRO_ALTA
	, CASE 
		WHEN UR.IND_STK_NEG IN ('X', 'Y') AND UR.IND_VENTA_REALIZADA = 'X' THEN 'E02'
		WHEN UR.IND_STK_NEG IN ('X', 'Y') AND UR.IND_BAJA_REALIZADA = 'X' THEN 'E03'
		WHEN UR.IND_STK_NEG IN ('X', 'Y') THEN '01'
		WHEN UR.IND_VENTA_REALIZADA = 'X' THEN '02'
		WHEN UR.IND_BAJA_REALIZADA = 'X' THEN '03'
		ELSE 'E99'
	  END IND_CONTROL_CARTERA		
	, CASE 
		WHEN UR.IND_STK_NEG IN ('X', 'Y') THEN 'STOCK'
		WHEN UR.IND_VENTA_REALIZADA = 'X' THEN 'VENTA'
		WHEN UR.IND_BAJA_REALIZADA = 'X' THEN 'BAJA'
		ELSE 'ERROR. DESCONOCIDO'
	  END CONTROL_CARTERA
	, 'PERIMETRO CARTERA - NUEVAS URS' ORIGEN_PERIMETRO
	, '' EXP_USR061
	, '' EXP_USR001
   , '' IND_DATA_ADHOC
	, 'X' IND_MIGRACION
	, 'POST MIGRACION' DETALLE_MIGRACION		
	, CAST(GETDATE() AS DATE) FECHA_CARGA
	, UR.FECHA_DATOS
	, '' IND_APORTACION

FROM [SVH_CORP_DB].[dbo].[UR_MAESTRO] UR
INNER JOIN #TMP_NUEVAS_URS_PERIMETRO NEW_UR 
	ON UR.SOCIEDAD = NEW_UR.SOCIEDAD 
	AND UR.UNIDAD_REGISTRAL = NEW_UR.UNIDAD_REGISTRAL



